#ifndef __MDFRAGMENTV1495_H
#define __MDFRAGMENTV1495_H

#include "MDdataContainer.h"
#include "MDfragment.h"
#include "MDdataWordV1495.h"
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>


class MDfragmentV1495 : public MDfragment {

 public:

  MDfragmentV1495(void *d = 0);
  virtual ~MDfragmentV1495(){}

  void SetDataPtr( void *d, uint32_t aSize );
  void Init();
  void Dump();

  unsigned int GetSpillNumber()  {return _spillNum;}
  unsigned int GetNumTriggers()  {return _nTriggers;}
  unsigned int GetGeo()          {return _geo;}

  unsigned int GetTriggerTime(unsigned int tr);
  unsigned long32 GetPatternTOF0(unsigned int tr, char p='n');
  unsigned long32 GetPatternTOF1(unsigned int tr, char p='n');
  unsigned long32 GetPatternTOF2(unsigned int tr, char p='n');

 private:

  unsigned int _geo;
  unsigned int _spillNum;     /// Number of Spills received by the DBB since last reset
  unsigned int _nTriggers;    /// Number of triggers received
};

ostream &operator<<(std::ostream &s,MDfragmentV1495 &df);

#endif


