/***************************************************************************
 *                                                                         *
 * $Log: MDpartEventPCI6254.h,v $
 * Revision 1.1  2009/04/21 12:45:29  daq
 * Initial revision
 *
 *                                                                         *
 * Originally created by J.S. Graulich, February 2009                      *
 *                                                                         *
 ***************************************************************************/

#ifndef __MDPARTEVENTPCI6254_H
#define __MDPARTEVENTPCI6254_H

#include "MDdataContainer.h"
#include "MDdataWordPCI6254.h"
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define  PCI6254_HEADER_SYNC 0xE0F00E0F

class MDpartEventPCI6254 : public MDdataContainer {

 public:
  
  MDpartEventPCI6254( void *d = 0 );
  virtual ~MDpartEventPCI6254(){}
  virtual void SetDataPtr( void *d );
  float  GetMeasurement(unsigned int ich, unsigned int iSample);
  float* GetSequence(unsigned int ich);

  void Init();
  unsigned int GetHeaderLength(){return _headerSize/4; }

  virtual void Dump( int atTheTime = 1 );
 private:
  unsigned int   _headerSize;
  unsigned int   _headerVersion;
  unsigned int   _clockRate;
  unsigned int   _nSamplesPerEvent;
  unsigned int   _nChannels;  
  unsigned int   _tv_sec;  
  unsigned int   _tv_usec;
  vector<float*> _vSeq;
};

#endif
